package mobicomp.net;

import java.io.IOException;
import java.util.Collections;
import java.util.Observable;
import java.util.Observer;
import java.util.Vector;

import mobicomp.interfaces.MHMessage;

/**
 * TODO
 * 
 * @author Andreas Wetzel <andi@spamato.net>
 */
public class RouteRequestHandler implements Observer
{
    private MHSocketImpl mhSocket;
    
    public RouteRequestHandler( MHSocketImpl socket) {
        mhSocket = socket;
    }
    
    /**
     * @see java.util.Observer#update(java.util.Observable, java.lang.Object)
     */
    public void update( Observable o, Object arg) {
    		MHMessage mhm = (MHMessage) arg;
        if (mhm.getType() != MHMessage.TYPE_RREQ) {
        		return;
        }

        // add local address to the messages route
        mhm.getRoute().add( new Integer( mhSocket.getOwnAddress()));

        try {
          if ( mhm.getReceiver() == mhSocket.getOwnAddress() ) {
              
              // answer with a route reply message
//              System.out.println( mhSocket.getOwnAddress() + ": " + mhm.getSender() + " is looking for me.");

              Vector route = mhm.getRoute();
              // reverse route
              Collections.reverse( route);
              
              MHMessage reply = new MHMessageImpl();
              reply.setType( MHMessage.TYPE_RREP);
              reply.setSender( mhSocket.getOwnAddress());
              reply.setReceiver( mhm.getSender());
              reply.setRoute( route);
              reply.setRouteIndex( 1);
              
              int nexthop = ((Integer)route.get( 1)).intValue();
              
              mhSocket.sendMHMessage( reply, nexthop);
          }
          else {
//              System.out.println( "forward flood");
              int ttl = mhm.getTTL();
              if ( (ttl > 1) || (ttl == 0) ) {
                  if ( ttl > 1 ) {
                      mhm.setTTL( ttl - 1);
                  }
                  mhSocket.broadcastMHMessage( mhm);
              }
          }
//          System.out.println( "storing hash" + mhm.getSender() + "/" + mhm.getFloodId());
      }
      catch (IOException e) {
          // TODO Auto-generated catch block
          e.printStackTrace();
      }

    }

}
